import java.awt.*;

public class Flower extends Plant
{
    private static double growthFactor = 0.25;


    /* Konstruktorer */
    public Flower()
    {
        super(new Color((int)(Math.random() * 200 + 55),
                        (int)(Math.random() * 200 + 55),
                        (int)(Math.random() * 200 + 55)),
              (int)(Math.random() * 6 + 5),
              Math.random() * 40 + 10,
              Math.random() * 30 + 10,
              Smell.NICE);
    }

    public Flower(Color color, double size)
    {
        super(color, DEF_LEAVS, DEF_HEIGHT, size, Smell.NICE);
    }

    public Flower(Color color, int leavs, double height,
                  double size, Smell smell)
    {
        super(color, leavs, height, size, smell);
    }

    /* Metoder - Frdigheter */

    public double getGrowthFactor()
    {
        return growthFactor;
    }

    public void capture(Fly f)
    {
        consume(f.getWeight());
    }

    public void paint(Graphics g)
    {
        int x = getX();
        int y = getY();
        g.setColor(Color.YELLOW);
        g.fillOval(x, y, (int)getSize(), (int)getSize());
        g.setColor(getColor());

        for (int i = 0; i < getLeavs(); i++) {
            g.fillOval(x + (int)(Math.sin(i * 2 * Math.PI / getLeavs()) *
                                 (getSize() * 0.75)),
                       y + (int)(Math.cos(i * 2 * Math.PI / getLeavs()) *
                                 (getSize() * 0.75)),
                       (int)getSize(), (int)getSize());
        }
    }

    public String toString()
    {
        return "I am a " + getHeight() +
            "cm tall flower and I smell " + getSmell() + ".";
    }
}
