import java.awt.*;
import java.util.*;
import javax.swing.*;

public class Garden extends JFrame
{
    private ArrayList<Plant> flowerBed = new ArrayList<Plant>();
    private ArrayList<Fly> flies = new ArrayList<Fly>();

    public Garden()
    {
        setSize(800,600);
        setVisible(true);

        Container garden = getContentPane();

        garden.add(new JPanel() {
                public void paintComponent(Graphics g)
                {
                    for (Plant p : flowerBed) {
                        p.paint(g);
                    }
                }
            });
    }

    public void addPlant(Plant b)
    {
        flowerBed.add(b);
    }


    public void addFly(Fly f)
    {
        flies.add(f);
    }


    public String toString()
    {
        String result = "";

        for (Plant f : flowerBed)
            result += f + "\n";

        for (Fly f : flies)
            result += f + "\n";

        return result;
    }

    public static void main(String[] args)
    {
        Garden eden = new Garden();

        /*
        eden.addPlant(new Flower());
        eden.addPlant(new Flower(Color.GREEN, 30));
        eden.addPlant(new Weed(Color.BLUE,
                               3, 23, 20, Smell.AWFUL));
        */

        for (int i = 0; i < 200; i++) {
            if (Math.random() < 0.90)
                eden.addPlant(new Flower());
            else
                eden.addPlant(new Weed());
        }

        eden.addFly(new Fly(3.14));
        eden.addFly(new Fly(2.17));

        //System.out.print(eden);
    }
}
